=== debian/changelog ===
opensurge (0.6.1.3+ds-1) unstable; urgency=medium

  * Initial release (Closes: #943676)

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 08 Feb 2026 14:47:56 +0100
