=== debian/control ===
Source: opensurge
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Carlos Donizete Froes <coringao@riseup.net>, Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
               debhelper-compat (= 13),
               liballegro-acodec5-dev,
               liballegro-audio5-dev,
               liballegro-dialog5-dev,
               liballegro-image5-dev,
               liballegro-ttf5-dev,
               liballegro-physfs5-dev,
               liballegro5-dev,
               libsurgescript-dev
Standards-Version: 4.7.3
Homepage: https://opensurge2d.org
Vcs-Browser: https://salsa.debian.org/games-team/opensurge
Vcs-Git: https://salsa.debian.org/games-team/opensurge.git

Package: opensurge
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         opensurge-data (= ${source:Version})
Description: Fun 2D retro platformer inspired by Sonic games
 Open Surge is a retro-style 2D sidescroller inspired by old-school games.
 .
 Join Surge, Neon and Charge and save the world from the evil Gimacian
 the Dark!
 .
 It has a game creation system that lets you unleash your creativity.
 Play, create games & share!

Package: opensurge-data
Architecture: all
Depends: ${misc:Depends},
         fonts-roboto-unhinted,
         fonts-noto-core,
         fonts-noto-extra
Suggests: opensurge
Description: Fun 2D retro platformer inspired by Sonic games - Game data
 You probably do not want to install this package manually. Please install
 opensurge to play the Open Surge game!
 .
 This package contains architecture-independent game data for Open Surge.
