=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -fPIE
export DEB_LDFLAGS_MAINT_APPEND = -pie

%:
	dh $@

override_dh_install:
	# filename must match component ID
	mv debian/tmp/usr/share/metainfo/opensurge.appdata.xml debian/tmp/usr/share/metainfo/org.opensurge2d.OpenSurge.appdata.xml
	# Avoid installation of documentation outside /usr/share/doc to make
	# lintian happy
	dh_install --all \
	    --exclude=LICENSE \
	    --exclude=README.txt \
	    --exclude=readme.txt \
	    --exclude=licenses/* \
	    --exclude=README.md \
	    --exclude=CONTRIBUTING.md \
	    --exclude=CHANGELOG.md
