=== debian/watch ===
Version: 5
Template: Github
Owner: alemart
Project: opensurge
Repack: yes
Repacksuffix: +ds
Dversion-Mangle: auto
